---
title: Firefox 24 for developers
slug: Mozilla/Firefox/Releases/24
tags:
  - Firefox
  - Firefox 24
---
<div>{{FirefoxSidebar}}</div><h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="CSS">CSS</h3>

<ul>
 <li>The two values <code>-moz-zoom-in</code> and <code>-moz-zoom-out</code> of the {{cssxref("cursor")}} property have been unprefixed to <code>zoom-in</code> and <code>zoom-out</code> ({{bug("772153")}}).</li>
 <li>To match the specification, the keywords <span id="summary_alias_container"><span id="short_desc_nonedit_display"><code>not</code>, <code>only</code>, <code>and</code>, and <code>or</code> cannot be used as media types anymore ({{bug("757554")}}).</span></span></li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>The {{HTMLElement("track")}} element has been implemented behind the <code>media.webvtt.enabled</code> preference, and is disabled by default. ({{bug(833385)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/arrow_functions">Arrow functions</a> are no longer automatically in strict mode unless explicitly requested with <code>"use strict"</code> ({{bug(852762)}}).</li>
 <li>The <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/repeat"><code>String.prototype.repeat</code></a> JS method has been implemented ({{bug(815431)}}).</li>
 <li>The {{jsxref("Set.prototype.values()")}}, {{jsxref("Set.prototype.keys()")}} and {{jsxref("Set.prototype.entries()")}} methods on {{jsxref("Set")}} objects have been implemented ({{bug("869996")}}).</li>
</ul>

<h3 id="DOM">DOM</h3>

<ul>
 <li>Support for the {{domxref("Range.Range", "Range()")}} constructor has been added ({{bug(868999)}}).</li>
 <li>Support for the {{domxref("Text.Text", "Text()")}} constructor has been added ({{bug(869000)}}).</li>
 <li>Support for the {{domxref("Comment.Comment", "Comment()")}} constructor has been added ({{bug(869006)}}).</li>
 <li>Support for the {{domxref("DocumentFragment.DocumentFragment", "DocumentFragment()")}} constructor has been added ({{bug(869002)}}).</li>
 <li>The {{domxref("FocusEvent")}} interface has been implemented ({{bug(855741)}}).</li>
 <li>Support for the {{domxref("ChildNode.remove()")}} method has been added ({{bug(856629)}}).</li>
 <li>The WebVTT interfaces related to the {{HTMLElement("track")}} element, {{domxref("HTMLTrackElement")}}, {{domxref("TextTrack")}}, {{domxref("TextTrackCue")}}, {{domxref("TextTrackList")}}, and {{domxref("TextTrackCueList")}} have been implemented behind the <code>media.webvtt.enabled</code> property, defaulting to <code>false</code> ({{bug(833385)}}).</li>
 <li>The {{domxref("Gamepad")}} interface, and {{domxref("Navigator.getGamepads")}} have been implemented behind the <code>dom.gamepad.enabled</code> property, defaulting to <code>false</code> ({{bug(690935)}}).</li>
 <li>On desktop Firefox only, <code>HTMLCanvasElement.getContext()</code> can now take the <code>webgl</code> value, in addition to <code>experimental-webgl</code> ({{bug(870232)}}).</li>
 <li>The non-standard method <code>mozLoadFrom()</code> of {{domxref("HTMLMediaElement")}} has been removed ({{bug(877135)}}).</li>
</ul>

<h3 id="Developer_Tools">Developer Tools</h3>

<ul>
 <li>The Network inspector now lets you filter by content type (CSS/image/font etc.) and see the relevant size and load times.</li>
 <li>The Devtools options panel to the left lets you disable/enable Javascript temporarily.</li>
 <li>Extension developers may use the new <a href="http://www.robodesign.ro/mihai/blog/the-browser-console-is-replacing-the-error-console">Browser Console</a> for Chrome-level scripts (Replaces Error Console).</li>
 <li>The source map syntax has been changed to use <code>//#</code> instead of <code>//@</code> ({{bug(870361)}}).</li>
</ul>

<h3 id="MathML">MathML</h3>

<ul>
 <li>The <code>dir</code> attribute for controlling directionality of formulas on e.g. {{MathMLElement("math")}} or {{MathMLElement("mrow")}} elements is now equivalent to using the {{cssxref("direction")}} CSS property.</li>
 <li>The equal sign ("=") is now <a href="/en-US/docs/Web/MathML/Element/mo#attr-stretchy">stretchable</a>.</li>
 <li>The "<code>updiagonalarrow</code>" value for the <code>notation</code> attribute on {{MathMLElement("menclose")}} elements has been added.</li>
</ul>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<ul>
 <li>Doc Shells have now the <code>allowMedia</code> attribute to disable media playing ({{bug(759964)}}).</li>
 <li>Sherlock search plugins in the application directory or profile  won't be loaded anymore ({{bug(862143)}}).</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://www.mozilla.org/en-US/firefox/24.0a2/auroranotes/">Firefox 24 Aurora Notes</a></li>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/24/">Site Compatibility for Firefox 24</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers('23')}}</p>
